<?php

namespace ByDedi\AdminBundle\Form\Extension;

use Sonata\AdminBundle\Form\Type\ModelAutocompleteType;
use Symfony\Component\Form\AbstractTypeExtension;
use Symfony\Component\Form\FormInterface;
use Symfony\Component\Form\FormView;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;

class ModelAutocompleteTypeExtension extends AbstractTypeExtension
{
    public function __construct()
    {
    }

    public function getExtendedType()
    {
        return ModelAutocompleteType::class;
    }

    /**
     * Set the default minimum input length to 2
     *
     * @param OptionsResolver $resolver
     */
    public function setDefaultOptions(\Symfony\Component\OptionsResolver\Options $resolver)
    {
        $resolver->setDefaults(
            [
                'minimum_input_length' => 2,
                'btn_add' => false,
                'btn_preview' => false,
                'btn_list' => false,
                'btn_catalogue' => false,
            ]
        );
    }

    /**
     * {@inheritdoc}
     */
    public function buildView(FormView $view, FormInterface $form, array $options)
    {
        $view->vars['minimum_input_length'] = $options['minimum_input_length'];
        $view->vars['btn_add'] = $options['btn_add'];
        $view->vars['btn_preview'] = $options['btn_preview'];
        $view->vars['btn_list'] = $options['btn_list'];
        $view->vars['btn_catalogue'] = $options['btn_catalogue'];
    }

    /**
     * Add the image_path option
     *
     * @param OptionsResolver $resolver
     */
    public function configureOptions(OptionsResolver $resolver)
    {
        $this->setDefaultOptions($resolver);
    }
}
