<?php
/**
 * Created by PhpStorm.
 * User: FrédéricGuichard
 * Date: 21/09/2016
 * Time: 17:11
 */

namespace ByDedi\AdminBundle\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\ButtonType;
use Symfony\Component\Form\FormInterface;
use Symfony\Component\Form\FormView;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;

class JavascriptActionButtonType extends AbstractType
{
    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults($this->getDefaultOptions());
    }

    public function getDefaultOptions()
    {
        return array(
            'required' => false,
            'mapped' => false,
            'by_reference' => false,
            'javascript' => '',
            'askConfirmation' => true,
            'show_label' => false,
            'ajax' => [
                'url' => '',
                'method' => 'post',
                'dataType' => 'json',
                'success' => 'function(data) {}',
                'data' => ''
            ],
            'confirmationText' => 'Souhaitez-vous vraiment effectuer cette action ?',
            'empty_data' => '',
            'template' => ''
        );
    }
    /**
     * {@inheritdoc}
     */
    public function buildView(FormView $view, FormInterface $form, array $options)
    {
        $defaultOptions = $this->getDefaultOptions();
        $attr = $view->vars['attr'];
        if (!isset($attr['class'])) {
            $attr['class'] = '';
        }
        $attr['class'].= 'btn btnLv1 btnIcon btn-sm sonata-ba-action button-javascript-action';

        $attr['data-javascript-action'] = "true";
        $view->vars['askConfirmation'] = $options['askConfirmation'];
        $view->vars['confirmationText'] = $options['confirmationText'];
        $view->vars['ajax'] = array_merge($defaultOptions['ajax'], $options['ajax']);
        $view->vars['hasScript'] = (!empty($options['javascript']) || !empty($options['ajax']['url']));
        $view->vars['javascript'] = $options['javascript'];
        $view->vars['attr'] = $attr;
        $view->vars['show_label'] = $options['show_label'];
        $view->vars['template'] = $options['template'];
    }


    // BC for SF < 3.0
    public function getName()
    {
        return $this->getBlockPrefix();
    }
}
